commit 18b4eb658f87d5122ccd3134e6c3f5d38a58cd5e
Author: freddy77 <freddy77>
Date:   Fri Jul 30 09:09:36 2010 +0000

    find a better way to export automatically without DEF changes

diff --git a/ChangeLog b/ChangeLog
index e656a36..95f173b 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Jul 30 11:08:37 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* configure.ac include/tdsodbc.h src/odbc/Makefile.am:
+	* src/odbc/odbc.c src/odbc/sqlwparams.h win32/FreeTDS.def:
+	* win32/Makefile.am:
+	- find a better way to export automatically without DEF changes
+
 Fri Jul 30 09:33:51 CEST 2010    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/tds/read.c: simplify tds_get_byte
 
@@ -2785,4 +2791,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog-0.82 added because of release
 	
 $FreeTDS$
-$Id: ChangeLog,v 1.3101 2010/07/30 07:34:06 freddy77 Exp $
+$Id: ChangeLog,v 1.3102 2010/07/30 09:09:36 freddy77 Exp $
diff --git a/configure.ac b/configure.ac
index 73f08ee..386f776 100644
--- a/configure.ac
+++ b/configure.ac
@@ -1,7 +1,7 @@
 dnl Process this file with autoconf to produce a configure script.
 
 dnl ------------------------------------------------------------
-dnl $Id: configure.ac,v 1.53 2010/07/30 07:17:27 freddy77 Exp $
+dnl $Id: configure.ac,v 1.54 2010/07/30 09:09:36 freddy77 Exp $
 dnl If you're trying to create a new configure test, try
 dnl
 dnl 	http://autogen.sourceforge.net/conftest.html
@@ -15,7 +15,7 @@ dnl ------------------------------------------------------------
 AC_INIT(FreeTDS, 0.83.dev.esyscmd(echo -n $(date +"%Y%m%d")))
 AC_CONFIG_SRCDIR(src/dblib/dblib.c)
 AC_PREREQ(2.53)
-AC_REVISION($Revision: 1.53 $)
+AC_REVISION($Revision: 1.54 $)
 
 AM_INIT_AUTOMAKE([dist-bzip2])
 AC_CONFIG_HEADERS(include/config.h)
@@ -774,7 +774,6 @@ AC_ARG_ENABLE(odbc-wide,
 if test "$enable_odbc_wide" = "yes" ; then
 	AC_DEFINE_UNQUOTED(ENABLE_ODBC_WIDE, 1, [Define to enable ODBC wide string support])
 fi
-AM_CONDITIONAL(ODBC_WIDE, test "$enable_odbc_wide" = "yes")
 
 AC_ARG_ENABLE(distcheck_build,
   AS_HELP_STRING([--enable-distcheck-build], [used internally for testing]))
diff --git a/include/tdsodbc.h b/include/tdsodbc.h
index 5dbe87d..4d80815 100644
--- a/include/tdsodbc.h
+++ b/include/tdsodbc.h
@@ -66,7 +66,7 @@ extern "C"
 #endif
 #endif
 
-/* $Id: tdsodbc.h,v 1.124 2010/07/17 19:58:24 freddy77 Exp $ */
+/* $Id: tdsodbc.h,v 1.125 2010/07/30 09:09:36 freddy77 Exp $ */
 
 #if defined(__GNUC__) && __GNUC__ >= 4 && !defined(__MINGW32__)
 #pragma GCC visibility push(hidden)
@@ -75,6 +75,16 @@ extern "C"
 #define ODBC_API SQL_API
 #endif
 
+#if defined(_WIN32) || defined(__CYGWIN__)
+#  ifdef __GNUC__
+#    define ODBC_PUBLIC __attribute__((dllexport))
+#  else
+#    define ODBC_PUBLIC __declspec(dllexport)
+#  endif
+#else
+#  define ODBC_PUBLIC
+#endif
+
 #define ODBC_MAX(a,b) ( (a) > (b) ? (a) : (b) )
 #define ODBC_MIN(a,b) ( (a) < (b) ? (a) : (b) )
 
diff --git a/src/odbc/Makefile.am b/src/odbc/Makefile.am
index b2e1f7f..a21d8c3 100644
--- a/src/odbc/Makefile.am
+++ b/src/odbc/Makefile.am
@@ -1,4 +1,4 @@
-# $Id: Makefile.am,v 1.49 2010/07/30 07:17:27 freddy77 Exp $
+# $Id: Makefile.am,v 1.50 2010/07/30 09:09:36 freddy77 Exp $
 SUBDIRS		= unittests
 AM_CPPFLAGS	=	-I$(top_srcdir)/include $(ODBC_INC)
 
@@ -13,14 +13,9 @@ libtdsodbc_la_SOURCES=	odbc.c connectparams.c convert_tds2sql.c \
 	descriptor.c prepare_query.c odbc_util.c \
 	native.c sql2tds.c error.c odbc_checks.c sqlwchar.c sqlwparams.h $(MINGW_SOURCES)
 if MINGW32
-if ODBC_WIDE
-DEFFILE = FreeTDSW.def
-else
-DEFFILE = FreeTDS.def
-endif
 libtdsodbc_la_LIBADD=	../../win32/setup.res ../tds/libtds.la ../replacements/libreplacements.la $(ODBCINSTLIB) \
 	$(NETWORK_LIBS) $(LIBICONV) $(FREETDS_LIBGCC)
-libtdsodbc_la_LDFLAGS = -Wl,--enable-stdcall-fixup -Wl,-s -Wl,$(top_srcdir)/win32/$(DEFFILE) -Wl,../../win32/setup.res $(FREETDS_SYMBOLIC)
+libtdsodbc_la_LDFLAGS = -Wl,--kill-at -Wl,--enable-stdcall-fixup -Wl,-s -Wl,$(top_srcdir)/win32/FreeTDS.def -Wl,../../win32/setup.res $(FREETDS_SYMBOLIC)
 
 .rc.res:
 	$(RC) -i $< -I $(top_builddir)/win32 --input-format=rc -o $@ -O coff
diff --git a/src/odbc/odbc.c b/src/odbc/odbc.c
index 78c2773..a9db1be 100644
--- a/src/odbc/odbc.c
+++ b/src/odbc/odbc.c
@@ -61,7 +61,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: odbc.c,v 1.548 2010/07/22 14:24:14 freddy77 Exp $");
+TDS_RCSID(var, "$Id: odbc.c,v 1.549 2010/07/30 09:09:36 freddy77 Exp $");
 
 static SQLRETURN _SQLAllocConnect(SQLHENV henv, SQLHDBC FAR * phdbc);
 static SQLRETURN _SQLAllocEnv(SQLHENV FAR * phenv, SQLINTEGER odbc_version);
@@ -2212,7 +2212,7 @@ SQLColAttribute(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType,
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLColAttributeW(SQLHSTMT hstmt, SQLUSMALLINT icol, SQLUSMALLINT fDescType,
 		SQLPOINTER rgbDesc, SQLSMALLINT cbDescMax, SQLSMALLINT FAR * pcbDesc,
 #ifdef TDS_SQLCOLATTRIBUTE_SQLLEN
@@ -4402,7 +4402,7 @@ SQLGetStmtAttr(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGE
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLGetStmtAttrW(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER Value, SQLINTEGER BufferLength, SQLINTEGER * StringLength)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetStmtAttr(%p, %d, %p, %d, %p)\n",
@@ -4805,7 +4805,7 @@ SQLGetConnectOption(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLPOINTER pvParam)
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLGetConnectOptionW(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLPOINTER pvParam)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLGetConnectOptionW(%p, %u, %p)\n", hdbc, fOption, pvParam);
@@ -5845,7 +5845,7 @@ SQLGetInfo(SQLHDBC hdbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLSMA
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLGetInfoW(SQLHDBC hdbc, SQLUSMALLINT fInfoType, SQLPOINTER rgbInfoValue, SQLSMALLINT cbInfoValueMax,
 	   SQLSMALLINT FAR * pcbInfoValue)
 {
@@ -5965,6 +5965,7 @@ SQLGetTypeInfo(SQLHSTMT hstmt, SQLSMALLINT fSqlType)
 			strcat(sql, ",3");
 		}
 	} else {
+		/* FIXME MS ODBC translate SQL_TIMESTAMP to SQL_TYPE_TIMESTAMP even for ODBC 2 apps */
 		sprintf(sql, sql_templ, fSqlType);
 	}
 	if (SQL_SUCCESS != odbc_set_stmt_query(stmt, (ODBC_CHAR*) sql, strlen(sql) _wide0))
@@ -6219,7 +6220,7 @@ SQLSetConnectOption(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLULEN vParam)
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLSetConnectOptionW(SQLHDBC hdbc, SQLUSMALLINT fOption, SQLULEN vParam)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLSetConnectOptionW(%p, %d, %u)\n", hdbc, fOption, (unsigned)vParam);
@@ -6520,7 +6521,7 @@ SQLSetStmtAttr(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINT
 }
 
 #ifdef ENABLE_ODBC_WIDE
-SQLRETURN ODBC_API
+SQLRETURN ODBC_PUBLIC ODBC_API
 SQLSetStmtAttrW(SQLHSTMT hstmt, SQLINTEGER Attribute, SQLPOINTER ValuePtr, SQLINTEGER StringLength)
 {
 	tdsdump_log(TDS_DBG_FUNC, "SQLSetStmtAttr(%p, %d, %p, %d)\n",
diff --git a/src/odbc/sqlwparams.h b/src/odbc/sqlwparams.h
index 8a83f67..3c8253c 100644
--- a/src/odbc/sqlwparams.h
+++ b/src/odbc/sqlwparams.h
@@ -20,7 +20,7 @@ static SQLRETURN FUNC;
 #define NAME(a) a
 #define WIDE
 #define PCHAR(a) SQLCHAR* a
-SQLRETURN ODBC_API FUNC {
+SQLRETURN ODBC_PUBLIC ODBC_API FUNC {
 
 #undef NAME
 #undef WIDE
@@ -43,7 +43,7 @@ SQLRETURN ODBC_API FUNC {
 #define WIDE
 #define P(a,b) a b
 #define PCHAR(a) SQLWCHAR * a
-SQLRETURN ODBC_API FUNC {
+SQLRETURN ODBC_PUBLIC ODBC_API FUNC {
 
 #undef NAME
 #undef WIDE
diff --git a/win32/FreeTDS.def b/win32/FreeTDS.def
index 97ea274..67308dd 100644
--- a/win32/FreeTDS.def
+++ b/win32/FreeTDS.def
@@ -78,4 +78,5 @@ EXPORTS
 	ConfigTranslator
 	DllRegisterServer
 	DllUnregisterServer
+	SQLGetTypeInfoW = SQLGetTypeInfo
 
diff --git a/win32/Makefile.am b/win32/Makefile.am
index a92213e..78190d0 100644
--- a/win32/Makefile.am
+++ b/win32/Makefile.am
@@ -1,5 +1,5 @@
 SUBDIRS	= msvc6
-EXTRA_DIST      = config.h FreeTDS.def FreeTDSW.def initnet.c \
+EXTRA_DIST      = config.h FreeTDS.def initnet.c \
 		tds_sysdep_public.h freetds_sysconfdir.h \
 		winsetup.c winlogin.c \
 		setup.rc resource.h \

